/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package db;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import model.Proizvod;

/**
 *
 * @author Korisnik
 */
public class DatabaseBroker {
    
    private Connection konekcija;
    
    public void uspostaviKonekciju() throws ClassNotFoundException, SQLException{
        try {
            Class.forName("com.mysql.jdbc.Driver");
            String url="jdbc:mysql://localhost:3306/racuni";
            String user="root";
            String password="root";
            
            konekcija=DriverManager.getConnection(url, user, password);
            konekcija.setAutoCommit(false);
            System.out.println("Uspesna konekcija");
        } catch (ClassNotFoundException ex) {
            System.out.println("Neuspesna konekcija");
            ex.printStackTrace();
            throw ex;
        } catch (SQLException ex) {
            System.out.println("Neuspesna konekcija");
            ex.printStackTrace();
            throw ex;
        }
    }
    
    public void raskiniKonekciju() throws SQLException{
        if(konekcija!=null){
            konekcija.close();
        }
        System.out.println("Uspesko raskinuta konekcija");
    }
    
    public void potvrdiTransakciju() throws SQLException{
        konekcija.commit();
        System.out.println("Uspesno potvrdjena transakcija!");
    }
    
    public void ponistiTransakciju() throws SQLException{
        konekcija.rollback();
        System.out.println("Uspesno ponistena transakcija!");
    }
    
    public void insertProizvod(Proizvod proizvod) throws SQLException{
        String upit="INSERT INTO Proizvod(proizvodID, naziv, cena) VALUES ("+proizvod.getProizvodID()+",'"+proizvod.getNaziv()+"',"+proizvod.getCena()+")";
        System.out.println(upit);
        try {
            Statement statement=konekcija.createStatement();
            statement.executeUpdate(upit);
            statement.close();
            System.out.println("Uspesno ubacen proizvod!");
        } catch (SQLException ex) {
            System.out.println("Neuspesno izvrsenje upita!");
            ex.printStackTrace();
            throw ex;
        }
    }
    
    public void insertProizvodPrepared(Proizvod proizvod) throws SQLException{
        String upit="INSERT INTO Proizvod (proizvodID, naziv, cena) VALUES (?,?,?)";
        System.out.println(upit);
        try {
            PreparedStatement ps=konekcija.prepareStatement(upit);
            ps.setInt(1, proizvod.getProizvodID());
            ps.setString(2, proizvod.getNaziv());
            ps.setDouble(3, proizvod.getCena());
            ps.executeUpdate();
            ps.close();
            System.out.println("Uspesno ubacen proizvod!");
        } catch (SQLException ex) {
            System.out.println("Neuspesno izvrsenje upita!");
            ex.printStackTrace();
            throw ex;
        }
    }
    
    public List<Proizvod> getAllProizvod() throws SQLException{
        ArrayList<Proizvod> proizvodi=new ArrayList<>();
        String upit="SELECT proizvodID, naziv, cena FROM Proizvod";
        try {
            Statement statement=konekcija.createStatement();
            ResultSet rs=statement.executeQuery(upit);
            
            while(rs.next()){
                Proizvod p=new Proizvod();
                p.setProizvodID(rs.getInt("proizvodID"));
                p.setNaziv(rs.getString("naziv"));
                p.setCena(rs.getDouble("cena"));
                proizvodi.add(p);
            }
            rs.close();
            statement.close();
        } catch (SQLException ex) {
            System.out.println("Neuspesno izvrsenje upita!");
            ex.printStackTrace();
            throw ex;
        }
        
        
        return proizvodi;
    }
    
    public void prikaziTabele(){
        try {
            ResultSet rs=konekcija.getMetaData().getTables(null, null, null, null);
            System.out.println("Tabele baze racuni:");
            while(rs.next()){
                String nazivTabele=rs.getString(3);
                System.out.println(nazivTabele);
                prikaziKolone(nazivTabele);
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseBroker.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    public void prikaziKolone(String nazivTabele){
        try {
            DatabaseMetaData metaData=konekcija.getMetaData();
            ResultSet rs=metaData.getColumns(null, null, nazivTabele, null);
            while(rs.next()){
                String naziv=rs.getString(3);
                String tip=rs.getString(4);
                int velicina=rs.getInt(7);
                System.out.println("\t"+naziv+", "+tip+", "+velicina);
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseBroker.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
}
