/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package logic;

import db.DatabaseBroker;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import model.Proizvod;

/**
 *
 * @author Korisnik
 */
public class Kontroler {

    private DatabaseBroker dbbr;

    public Kontroler() {
        dbbr = new DatabaseBroker();
    }

    public void ubaciProizvod(Proizvod p) throws Exception {
        try {
            dbbr.uspostaviKonekciju();
        } catch (Exception ex) {
            throw new Exception("Greska prilikom uspostavljanja konekcije!");
        }

        try {
            //dbbr.insertProizvod(p);
            dbbr.insertProizvodPrepared(p);
            dbbr.potvrdiTransakciju();
        } catch (Exception e) {
            dbbr.ponistiTransakciju();
            throw new Exception("Greska prilikom ubacivanja proizvoda!");
        } finally {
            {
                try {
                    dbbr.raskiniKonekciju();
                } catch (Exception e) {
                    throw new Exception("Greska prilikom raskidanja konekcije!");
                }
            }
        }
    }

    public List<Proizvod> vratiSveProizvode() throws Exception {
        List<Proizvod> proizvodi = null;

        try {
            dbbr.uspostaviKonekciju();
        } catch (Exception ex) {
            throw new Exception("Greska prilikom uspostavljanja konekcije!");
        }

        try {
            proizvodi = dbbr.getAllProizvod();
            dbbr.potvrdiTransakciju();
        } catch (Exception e) {
            dbbr.ponistiTransakciju();
            throw new Exception("Greska prilikom ubacivanja proizvoda!");
        } finally {

            try {
                dbbr.raskiniKonekciju();
            } catch (Exception e) {
                throw new Exception("Greska prilikom raskidanja konekcije!");
            }
        }
        return proizvodi;
    }

    public void sacuvajListuProizvoda(List<Proizvod> proizvodi) throws Exception {

        try {
            dbbr.uspostaviKonekciju();
        } catch (Exception ex) {
            throw new Exception("Greska prilikom uspostavljanja konekcije!");
        }

        try {
            for (Proizvod proizvod : proizvodi) {
                dbbr.insertProizvodPrepared(proizvod);
            }
            dbbr.potvrdiTransakciju();
        } catch (Exception e) {
            dbbr.ponistiTransakciju();
            throw new Exception("Greska prilikom ubacivanja proizvoda!");
        } finally {

            try {
                dbbr.raskiniKonekciju();
            } catch (Exception e) {
                throw new Exception("Greska prilikom raskidanja konekcije!");
            }
        }
    }
    
    public void metaPodaci() throws Exception {

        try {
            dbbr.uspostaviKonekciju();
        } catch (Exception ex) {
            throw new Exception("Greska prilikom uspostavljanja konekcije!");
        }

        try {
            dbbr.prikaziTabele();
            dbbr.potvrdiTransakciju();
        } catch (Exception e) {
            dbbr.ponistiTransakciju();
            throw new Exception("Greska prilikom ubacivanja proizvoda!");
        } finally {

            try {
                dbbr.raskiniKonekciju();
            } catch (Exception e) {
                throw new Exception("Greska prilikom raskidanja konekcije!");
            }
        }
    }
}
